VERSION 5.00
Object = "{96872FA0-D44C-11D1-A898-0020AFF84CB3}#1.0#0"; "VIDEO.OCX"
Begin VB.Form Main 
   Caption         =   "Video.Ocx-Demo"
   ClientHeight    =   3390
   ClientLeft      =   180
   ClientTop       =   825
   ClientWidth     =   5550
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'ZReihenfolge
   ScaleHeight     =   226
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   370
   Begin VideoLib.VideoCapture VideoCapture1 
      Height          =   2415
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3855
      _Version        =   65536
      _ExtentX        =   6800
      _ExtentY        =   4260
      _StockProps     =   1
      PreviewRate     =   40
   End
   Begin VB.Label StatusZeile2 
      BorderStyle     =   1  'Fest Einfach
      Height          =   255
      Left            =   900
      TabIndex        =   2
      Top             =   3120
      Width           =   4650
   End
   Begin VideoLib.Codec Decoder 
      Left            =   5040
      Top             =   240
      _Version        =   65536
      _ExtentX        =   661
      _ExtentY        =   661
      _StockProps     =   0
   End
   Begin VideoLib.Codec Encoder 
      Left            =   4560
      Top             =   240
      _Version        =   65536
      _ExtentX        =   661
      _ExtentY        =   661
      _StockProps     =   0
   End
   Begin VB.Label StatusZeile1 
      Alignment       =   1  'Rechts
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "fps "
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   3120
      Width           =   855
   End
   Begin VB.Menu menu_datei 
      Caption         =   "&Datei"
      Begin VB.Menu menu_saveasavi 
         Caption         =   "&Speichern als AVI"
         Begin VB.Menu menu_saveasavi1 
            Caption         =   "Sequenz"
         End
         Begin VB.Menu menu_saveasavi2 
            Caption         =   "einzelnes Bild"
         End
      End
      Begin VB.Menu menu_d1 
         Caption         =   "-"
      End
      Begin VB.Menu menu_ende 
         Caption         =   "&Beenden"
      End
   End
   Begin VB.Menu menu_edit 
      Caption         =   "&Bearbeiten"
      Begin VB.Menu menu_copy 
         Caption         =   "&Kopieren"
         Shortcut        =   ^{INSERT}
      End
   End
   Begin VB.Menu menu_quelle 
      Caption         =   "&Quelle"
      Begin VB.Menu menu_device 
         Caption         =   "(keine Kamera verfgbar)"
         Enabled         =   0   'False
         Index           =   0
      End
      Begin VB.Menu menu_q1 
         Caption         =   "-"
      End
      Begin VB.Menu menu_avi 
         Caption         =   "Avi-Datei"
         Shortcut        =   {F5}
      End
   End
   Begin VB.Menu menu_codec 
      Caption         =   "&Komprimierung"
      Begin VB.Menu menu_selectcodec 
         Caption         =   "&Auswahl..."
         Shortcut        =   {F2}
      End
      Begin VB.Menu menu_codec_video1 
         Caption         =   """Microsoft Video 1""-Codec"
         Shortcut        =   {F3}
      End
      Begin VB.Menu menu_nocodec 
         Caption         =   "keine Komprimierung"
         Shortcut        =   {F4}
      End
   End
   Begin VB.Menu menu_ansicht 
      Caption         =   "&Ansicht"
      Begin VB.Menu menu_ansicht_kamerabild 
         Caption         =   "Kamerabild"
      End
      Begin VB.Menu menu_ansicht_encoderausgang 
         Caption         =   "Encoder-Ausgang"
      End
      Begin VB.Menu menu_ansicht_decoderausgang 
         Caption         =   "Decoder-Ausgang"
      End
   End
   Begin VB.Menu menu_optionen 
      Caption         =   "&Optionen"
      Begin VB.Menu menu_preview 
         Caption         =   "Preview"
      End
      Begin VB.Menu menu_o1 
         Caption         =   "-"
      End
      Begin VB.Menu menu_dlg_format 
         Caption         =   "&Format-Dialog"
      End
      Begin VB.Menu menu_dlg_source 
         Caption         =   "&Source-Dialog"
      End
      Begin VB.Menu menu_dlg_display 
         Caption         =   "&Display-Dialog"
      End
      Begin VB.Menu menu_dlg_compression 
         Caption         =   "&Compression-Dialog"
      End
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Const WM_CAP_EDIT_COPY = &H41E

Public Kamerabild As Form
Public AnsichtDecoder As Form
Public AnsichtEncoder As Form

Dim capture_size&

Private Sub Decoder_OnFrame(ByVal bmph As Long, ByVal data As Long, ByVal size As Long)

AnsichtDecoder.VideoShow1.Draw bmph, data
AnsichtDecoder.Caption = "Decoder Ausgang: " + Decoder.Codec

End Sub

Private Sub Encoder_OnFrame(ByVal bmph As Long, ByVal data As Long, ByVal size As Long)

On Error Resume Next
StatusZeile2.Caption = " " + Encoder.Codec + " / " + Str$(Encoder.FrameNr + 1) + " von" + Str$(Encoder.KeyFrame) + " /" + Str$(capture_size&) + " >" + Str$(size) + " =" + Str$(Int(0.5 + 1000# * size / capture_size&) / 10) + "%"
On Error GoTo 0

If Not (AnsichtEncoder Is Nothing) Then
   AnsichtEncoder.VideoShow1.Draw bmph, data
End If

If Not (AnsichtDecoder Is Nothing) Then
   Decoder.DecodeFrame bmph, data, size
End If

End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)

If KeyAscii = 27 Then VideoCapture1.StopAvi

End Sub

Private Sub Form_Load()

menu_preview.Checked = VideoCapture1.PreviewRate > 0

Set Kamerabild = Nothing
Set AnsichtDecoder = Nothing
Set AnsichtEncoder = Nothing

For n% = 0 To 9
   If Len(VideoCapture1.DeviceName(n%)) Then
      If n% Then Load menu_device(n%)
      menu_device(n%).Visible = True
      menu_device(n%).Enabled = True
      menu_device(n%).Caption = VideoCapture1.DeviceName(n%)
      menu_device(n%).Checked = False
      
      ''Capture sofort einschalten
      'If n% = VideoCapture1.DeviceNr Then menu_device_Click n%
   End If
Next

End Sub

Private Sub Form_Resize()

StatusZeile1.Top = Me.ScaleHeight - 18
StatusZeile2.Top = Me.ScaleHeight - 18
If Me.ScaleWidth > 60 Then StatusZeile2.Width = Me.ScaleWidth - StatusZeile2.Left

End Sub

Private Sub Form_Unload(Cancel As Integer)

VideoCapture1.Capture = False

If Not (Kamerabild Is Nothing) Then Unload Kamerabild
If Not (AnsichtDecoder Is Nothing) Then Unload AnsichtDecoder
If Not (AnsichtEncoder Is Nothing) Then Unload AnsichtEncoder

End Sub

Private Sub menu_ansicht_decoderausgang_Click()

If AnsichtDecoder Is Nothing Then
   Set AnsichtDecoder = New Anzeige
   AnsichtDecoder.Caption = "Decoder Ausgang"
End If
AnsichtDecoder.Show

End Sub

Private Sub menu_ansicht_encoderausgang_Click()

If AnsichtEncoder Is Nothing Then
   Set AnsichtEncoder = New Anzeige
   AnsichtEncoder.Caption = "Encoder Ausgang"
End If
AnsichtEncoder.Show

End Sub

Private Sub menu_ansicht_kamerabild_Click()

If Kamerabild Is Nothing Then
   Set Kamerabild = New Anzeige
   Kamerabild.Caption = "Kamerabild"
End If
Kamerabild.Show

End Sub

Private Sub menu_avi_Click()

a$ = InputBox$("AVI-Dateiname", "AVI abspielen", Dir$("*.avi"))
If Len(a$) = 0 Then Exit Sub

menu_device(VideoCapture1.DeviceNr).Checked = False

VideoCapture1.PlayAvi a$

End Sub

Private Sub menu_codec_video1_Click()

Encoder.Codec = "msvc"
Encoder.Quality = 8000
Encoder.KeyFrame = 9

End Sub

Private Sub menu_copy_Click()

l& = SendMessage(VideoCapture1.hwnd, WM_CAP_EDIT_COPY, 0, 0)

End Sub

Private Sub menu_device_Click(Index As Integer)

If menu_device(Index).Checked Then
   menu_device(Index).Checked = False
   VideoCapture1.Capture = False
Else
   menu_device(VideoCapture1.DeviceNr).Checked = False
   menu_device(Index).Checked = True
   VideoCapture1.DeviceNr = Index
   VideoCapture1.Capture = True
   If VideoCapture1.Height > Me.ScaleHeight - 22 Then
      Me.Height = Me.Height + (-Me.ScaleHeight + 22 + VideoCapture1.Height) * Screen.TwipsPerPixelY
   End If
End If

End Sub

Private Sub menu_dlg_compression_Click()

VideoCapture1.DlgCompression

End Sub

Private Sub menu_dlg_display_Click()

VideoCapture1.DlgDisplay

End Sub

Private Sub menu_dlg_format_Click()

VideoCapture1.DlgFormat
   
End Sub

Private Sub menu_dlg_source_Click()

VideoCapture1.DlgSource

End Sub

Private Sub menu_ende_Click()

Unload Me

End Sub

Private Sub menu_nocodec_Click()

Encoder.NoCodec

End Sub

Private Sub menu_optionen_Click()

menu_dlg_format.Enabled = VideoCapture1.DlgFormatQuery
menu_dlg_source.Enabled = VideoCapture1.DlgSourceQuery
menu_dlg_display.Enabled = VideoCapture1.DlgDisplayQuery
menu_dlg_compression.Enabled = VideoCapture1.Capture

End Sub

Private Sub menu_datei_Click()

menu_saveasavi.Enabled = VideoCapture1.Capture

End Sub

Private Sub menu_edit_Click()

menu_copy.Enabled = VideoCapture1.Capture

End Sub

Private Sub menu_preview_Click()

menu_preview.Checked = True - menu_preview.Checked
VideoCapture1.PreviewRate = -menu_preview.Checked * 40

End Sub

Private Sub menu_saveasavi1_Click()

If menu_saveasavi1.Checked Then
   VideoCapture1.CaptureSequenceStop
Else
   a$ = InputBox$("AVI-Dateiname", "Mitschneiden als Avi - Sequenz")
   If Len(a$) = 0 Then Exit Sub
   VideoCapture1.CaptureSequenceStart a$
End If

menu_saveasavi1.Checked = True - menu_saveasavi1.Checked

End Sub

Private Sub menu_saveasavi2_Click()

a$ = InputBox$("AVI-Dateiname", "Mitschneiden als Avi - einzelnes Bild")
If Len(a$) = 0 Then Exit Sub
VideoCapture1.CaptureSingleFrame a$

End Sub

Private Sub menu_selectcodec_Click()

Encoder.SelectCodec

End Sub

Private Sub VideoCapture1_OnFrame(ByVal bmph As Long, ByVal data As Long, ByVal size As Long)

On Error Resume Next
Static t#
t1# = Timer
StatusZeile1.Caption = Format$(1 / (t1# - t#), "0.0") + " fps "
t# = t1#
On Error GoTo 0

fmt$ = VideoCapture1.Compression: If fmt$ = "" Then fmt$ = "RGB"
StatusZeile2.Caption = " " + fmt$ + "," + Str$(VideoCapture1.Colors) + " Bits Farben"
capture_size& = size

If Not (Kamerabild Is Nothing) Then
   Kamerabild.VideoShow1.Draw bmph, data
End If

If Not (AnsichtEncoder Is Nothing) Or Not (AnsichtDecoder Is Nothing) Then
   Encoder.EncodeFrame bmph, data, size
End If

End Sub

